summaryrefslogtreecommitdiffstats
path: root/postgresql/bin
diff options
context:
space:
mode:
authorDaniel Baumann <mail@daniel-baumann.ch>2022-04-30 21:23:16 +0000
committerDaniel Baumann <daniel.baumann@open-infrastructure.net>2023-06-20 04:27:57 +0000
commit5483b2af3413e9d191e989bf11ccabf5ad206e20 (patch)
treea2b4ae0ca69cbbaae23d135b4d153b7049aedcf0 /postgresql/bin
parentopenssh (WIP) (diff)
downloadservice-tools-5483b2af3413e9d191e989bf11ccabf5ad206e20.tar.xz
service-tools-5483b2af3413e9d191e989bf11ccabf5ad206e20.zip
postgresql (WIP)
Signed-off-by: Daniel Baumann <mail@daniel-baumann.ch>
Diffstat (limited to 'postgresql/bin')
-rwxr-xr-xpostgresql/bin/pg_hba.conf169
-rwxr-xr-xpostgresql/bin/postgresql-backup47
2 files changed, 216 insertions, 0 deletions
diff --git a/postgresql/bin/pg_hba.conf b/postgresql/bin/pg_hba.conf
new file mode 100755
index 0000000..2b6c7cb
--- /dev/null
+++ b/postgresql/bin/pg_hba.conf
@@ -0,0 +1,169 @@
+#!/bin/sh
+
+# Open Infrastructure: service-tools
+
+# Copyright (C) 2014-2022 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# SPDX-License-Identifier: GPL-3.0+
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+set -e
+
+PROGRAM="$(basename "${0}")"
+
+Parameters ()
+{
+ GETOPT_LONGOPTIONS="add,init,remove,update"
+ GETOPT_OPTIONS="a,i,r,u,"
+
+ PARAMETERS="$(getopt --longoptions ${GETOPT_LONGOPTIONS} --name=${COMMAND} --options ${GETOPT_OPTIONS} --shell sh -- ${@})"
+
+ if [ "${?}" != "0" ]
+ then
+ echo "'${COMMAND}': getopt exit" >&2
+ exit 1
+ fi
+
+ eval set -- "${PARAMETERS}"
+
+ while true
+ do
+ case "${1}" in
+ -a|--add)
+ ACTION="add"
+ shift 1
+ ;;
+
+ -i|--init)
+ ACTION="init"
+ shift 1
+ ;;
+
+ -r|--remove)
+ ACTION="remove"
+ shift 1
+ ;;
+
+ -u|--update)
+ ACTION="update"
+ shift 1
+ ;;
+
+ --)
+ shift 1
+ break
+ ;;
+
+ *)
+ echo "'${COMMAND}': getopt error" >&2
+ exit 1
+ ;;
+ esac
+ done
+}
+
+Usage ()
+{
+ echo "Usage: ${PROGRAM} [-i|--init] [-a|--add LINE] [-r|--remove LINE] [-u|--update]" >&2
+ echo
+ echo "See ${PROGRAM}(1) for more information."
+
+ exit 1
+}
+
+Parameters "${@}"
+
+Run_add()
+{
+ echo "'add' not implemented yet"
+ exit 0
+}
+
+Run_init()
+{
+ echo "'init' not implemented yet"
+ exit 0
+}
+
+Run_remove()
+{
+ echo "'remove' not implemented yet"
+ exit 0
+}
+
+Run_update()
+{
+ # Check for pg_hba.conf
+ if ! ls /etc/postgresql/*/*/pg_hba.conf > /dev/null 2>&1
+ then
+ echo "W: no pg_hba.conf in /etc/postgresql found." >&2
+ exit 1
+ fi
+
+ # Check for managed pg_hba.conf
+ if ! ls /etc/postgresql/*/*/pg_hba.conf.g > /dev/null 2>&1
+ then
+ echo "W: no managed pg_hba.conf in /etc/postgresql found, maybe use '${PROGRAM} --init' first." >&2
+ exit 1
+ fi
+
+ # Update pg_hba.conf from pg_hba.conf.g directories
+ for DIRECTORY in /etc/postgresql/*/*/pg_hba.conf.g
+ do
+ if ls "${DIRECTORY}"/*.conf > /dev/null 2>&1
+ then
+ CONFIG="$(basename "${DIRECTORY}" .g)"
+
+ echo -n "Updating ${CONFIG}..."
+
+ rm -f "${CONFIG}"
+
+ for FILE in "${DIRECTORY}"/*.conf
+ do
+ cat "${FILE}" >> "${CONFIG}"
+ done
+
+ echo " done."
+ fi
+ done
+}
+
+case "${PROGRAM}" in
+ update-pg_hba.conf)
+ ACTION="update"
+ ;;
+esac
+
+case "${ACTION}" in
+ add)
+ Run_add
+ ;;
+
+ init)
+ Run_init
+ ;;
+
+ remove)
+ Run_remove
+ ;;
+
+ update)
+ Run_update
+ ;;
+
+ *)
+ Usage
+ ;;
+esac
diff --git a/postgresql/bin/postgresql-backup b/postgresql/bin/postgresql-backup
new file mode 100755
index 0000000..beaf2d8
--- /dev/null
+++ b/postgresql/bin/postgresql-backup
@@ -0,0 +1,47 @@
+#!/bin/sh
+
+# Open Infrastructure: service-tools
+
+# Copyright (C) 2014-2022 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# SPDX-License-Identifier: GPL-3.0+
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+set -e
+
+
+#!/bin/sh
+
+set -e
+
+DIRECTORY="/srv/$(cat /etc/hostname)/postgresql-backup/$(date +%Y-%m-%d)"
+DATABASES="fbm_test"
+
+mkdir -p "${DIRECTORY}"
+chown -R postgres:postgres "${DIRECTORY}"
+
+for DATABASE in ${DATABASES}
+do
+ su - postgres -c "pg_dump -f ${DIRECTORY} -F d -j $(nproc) -C -d ${DATABASE}"
+done
+
+chown -R root:root "${DIRECTORY}"
+
+
+
+
+# FIXME
+#postgres pg_dump ${DATABASE} | plzip > postgresql-backup/${DATABASE}-"$(date +\%Y\%m\%d)".sql.lz
+#find postgresql-backup/ -mtime +90 -name "${DATABASE}-*lz" | xargs -r rm